@inproceedings{Viera:2009:AGF:1596550.1596586,
 author = {Viera, Marcos and Swierstra, S. Doaitse and Swierstra, Wouter},
 title = {Attribute Grammars Fly First-class: How to Do Aspect Oriented Programming in Haskell},
 booktitle = {Proceedings of the 14th ACM SIGPLAN International Conference on Functional Programming},
 series = {ICFP '09},
 year = {2009},
 isbn = {978-1-60558-332-7},
 location = {Edinburgh, Scotland},
 pages = {245--256},
 numpages = {12},
 url = {http://doi.acm.org/10.1145/1596550.1596586},
 doi = {10.1145/1596550.1596586},
 acmid = {1596586},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {HList, Haskell, attribute grammars, class system, lazy evaluation, type-level programming},
} 

@inproceedings{Kiselyov:2004:STH:1017472.1017488,
 author = {Kiselyov, Oleg and L\"{a}mmel, Ralf and Schupke, Keean},
 title = {Strongly Typed Heterogeneous Collections},
 booktitle = {Proceedings of the 2004 ACM SIGPLAN Workshop on Haskell},
 series = {Haskell '04},
 year = {2004},
 isbn = {1-58113-850-4},
 location = {Snowbird, Utah, USA},
 pages = {96--107},
 numpages = {12},
 url = {http://doi.acm.org/10.1145/1017472.1017488},
 doi = {10.1145/1017472.1017488},
 acmid = {1017488},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {collections, dependently typed programming, extensible records, haskell, type equality, type improvement, type-indexed rows, type-safe database access},
} 



@article{Hall:1996:TCH:227699.227700,
 author = {Hall, Cordelia V. and Hammond, Kevin and Peyton Jones, Simon L. and Wadler, Philip L.},
 title = {Type Classes in Haskell},
 journal = {ACM Trans. Program. Lang. Syst.},
 issue_date = {March 1996},
 volume = {18},
 number = {2},
 month = mar,
 year = {1996},
 issn = {0164-0925},
 pages = {109--138},
 numpages = {30},
 url = {http://doi.acm.org/10.1145/227699.227700},
 doi = {10.1145/227699.227700},
 acmid = {227700},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {Haskell, functional programming, type classes, types},
} 


@inproceedings{DBLP:conf/esop/Jones00,
  author    = {Mark P. Jones},
  title     = {Type Classes with Functional Dependencies},
  booktitle = {{ESOP}},
  series    = {Lecture Notes in Computer Science},
  volume    = {1782},
  pages     = {230--244},
  publisher = {Springer},
  year      = {2000}
}

@INPROCEEDINGS{Hallgren00funwith,
    author = {Thomas Hallgren},
    title = {Fun with Functional Dependencies},
    booktitle = {Proc. of the Joint CS/CE Winter Meeting},
    year = {2000}
}

@article{parker:tlii,
	Author = {Conrad Parker},
	Journal = {The Monad.Reader},
	Month = {September},
	Title = {{Type-Level Instant Insanity}},
	Volume = {Issue Eight},
	Year = {2007}
}

@misc{OlegSKI,
  Author = {Oleg Kiselyov},
  title = {{Type-level call-by-value lambda-calculator in three lines}},
  howpublished = {http://okmij.org/ftp/Computation/lambda-calc.html},
  note = {Accedido: 28-5-2018}
}


@inproceedings{Yorgey:2012:GHP:2103786.2103795,
 author = {Yorgey, Brent A. and Weirich, Stephanie and Cretin, Julien and Peyton Jones, Simon and Vytiniotis, Dimitrios and Magalh\~{a}es, Jos{\'e} Pedro},
 title = {Giving Haskell a Promotion},
 booktitle = {Proceedings of the 8th ACM SIGPLAN Workshop on Types in Language Design and Implementation},
 series = {TLDI '12},
 year = {2012},
 isbn = {978-1-4503-1120-5},
 location = {Philadelphia, Pennsylvania, USA},
 pages = {53--66},
 numpages = {14},
 url = {http://doi.acm.org/10.1145/2103786.2103795},
 doi = {10.1145/2103786.2103795},
 acmid = {2103795},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {haskell, kinds, polymorphism, promotion},
} 


 [download]

@article{Lindley:2013:HPP:2578854.2503786,
 author = {Lindley, Sam and McBride, Conor},
 title = {Hasochism: The Pleasure and Pain of Dependently Typed Haskell Programming},
 journal = {SIGPLAN Not.},
 issue_date = {December 2013},
 volume = {48},
 number = {12},
 month = sep,
 year = {2013},
 issn = {0362-1340},
 pages = {81--92},
 numpages = {12},
 url = {http://doi.acm.org/10.1145/2578854.2503786},
 doi = {10.1145/2578854.2503786},
 acmid = {2503786},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {data type promotion, dependent types, invariants, proof search, singletons},
} 


